diff --git a/web/pgadmin/static/js/slickgrid/slick.grid.js b/web/pgadmin/static/js/slickgrid/slick.grid.js
index 796e161..a57a659 100644
--- a/web/pgadmin/static/js/slickgrid/slick.grid.js
+++ b/web/pgadmin/static/js/slickgrid/slick.grid.js
@@ -1337,7 +1337,7 @@ if (typeof Slick === "undefined") {
     }
 
     function getDataLengthIncludingAddNew() {
-      return getDataLength() + (options.enableAddRow ? 1 : 0);
+      return getDataLength() + (options.enableAddRow ? 2 : 1);
     }
 
     function getDataItem(i) {
@@ -1461,12 +1461,13 @@ if (typeof Slick === "undefined") {
     function appendRowHtml(stringArray, row, range, dataLength) {
       var d = getDataItem(row);
       var dataLoading = row < dataLength && !d;
+      var diff = dataLength - row;
       var rowCss = "slick-row" +
           (dataLoading ? " loading" : "") +
           (row === activeRow ? " active" : "") +
-          (row % 2 == 1 ? " odd" : " even");
+          (((options.enableAddRow && diff < 0) || diff == 0) ? "" : (row % 2 == 1 ? " odd" : " even"));
 
-      if (!d) {
+      if (!d && options.enableAddRow && diff == 0) {
         rowCss += " " + options.addNewRowCssClass;
       }
 
@@ -1478,6 +1479,11 @@ if (typeof Slick === "undefined") {
 
       stringArray.push("<div class='ui-widget-content " + rowCss + "' style='top:" + getRowTop(row) + "px'>");
 
+      if (options.enableAddRow ? diff < 0 : diff == 0) {
+        stringArray.push("</div>");
+        return;
+      }
+
       var colspan, m;
       for (var i = 0, ii = columns.length; i < ii; i++) {
         m = columns[i];
@@ -1521,6 +1527,12 @@ if (typeof Slick === "undefined") {
         cellCss += (" active");
       }
 
+      if (!item) {
+          var diff = getDataLength() - row;
+          if (options.enableAddRow ? diff < 0 : diff == 0)
+            return;
+      }
+
       // TODO:  merge them together in the setter
       for (var key in cellCssClasses) {
         if (cellCssClasses[key][row] && cellCssClasses[key][row][m.id]) {
